SuperStrict

Framework BRL.Max2D
Import BRL.D3D7Max2D
Import BRL.Retro
Import BRL.PNGLoader

Incbin "player.png"
Incbin "tiles.png"
Incbin "background.png"

Const FORM_JUMP_LOW%=0
Const FORM_JUMP_MID%=1
Const FORM_JUMP_HIGH%=2
Const FORM_DUCK%=3

Type THurdle
	Field form%[4,13],pos%,scroll% Ptr

	Method update()
		SetScale 1,1
		For i=0 To 3
			For j=0 To 12
				If form[i,j] Then CollideImage tiles,pos-scroll[0]+i*16,j*16,0,0,1
			Next
		Next
	End Method

	Method draw()
		For i=0 To 3
			For j=0 To 12
				If form[i,j] Then DrawImage tiles,(pos-scroll[0]+i*16)*z,j*16*z,0
			Next
		Next
	End Method

	Function create:THurdle(pos% , scroll% Ptr , form%)
		Local hurdle:THurdle=New THurdle,jfrom%,jto%

		hurdle.pos=pos
		hurdle.scroll=scroll

		Select form
		Case FORM_JUMP_LOW
			jfrom=11
			jto=12
		Case FORM_JUMP_MID
			jfrom=9
			jto=12
		Case FORM_JUMP_HIGH
			jfrom=7
			jto=12
		Case FORM_DUCK
			jfrom=0
			jto=11
		End Select

		For i=0 To 3
			For j=jfrom To jto
				hurdle.form[i,j] = 1
			Next
		Next

		Return hurdle
	End Function			
End Type

AppTitle:String = "Super Dodge 'n Jump!"
Global i%,j%,z%=2,sprite:TImage,tiles:TImage,background:TImage
Local stream:TStream=ReadStream("config.txt"),hurdles:TList=New TList,h:THurdle,scroll%,timer%,level%,count#=4,sel%,anim%,py#,vely#,charge%,panim#,dead%,x%,y%
If stream<>Null Then
ReadLine stream
ReadLine stream
z=Int(ReadLine(stream))
CloseStream stream
EndIf
SetGraphicsDriver D3D7Max2DDriver()
Graphics 320*z,240*z,0,60
SetBlend ALPHABLEND
SetClsColor 100,180,200 '100,140,60
SetMaskColor 9,9,9
sprite=LoadAnimImage("incbin::player.png",32,32,0,3,MASKEDIMAGE)
tiles=LoadAnimImage("incbin::tiles.png",16,16,0,2,MASKEDIMAGE)
background=LoadAnimImage("incbin::background.png",64,32,0,2,MASKEDIMAGE)

Repeat
If count>0 Then
count:-0.016
ElseIf dead Then
If KeyHit(KEY_LEFT) Or KeyHit(KEY_RIGHT) Then sel=1-sel
If KeyDown(KEY_ENTER) Then
If sel Then End
py=0;vely=0;panim=0;dead=0
scroll=0
hurdles.clear()
timer=0
level=0
count=4
EndIf
Else
If timer=0 Then
hurdles.addlast(THurdle.create(scroll+320,Varptr scroll,Rnd(4)))
level:+1
timer=320-level*16
If timer<112 Then timer=112
EndIf
timer:-1
scroll:+2
For h=EachIn hurdles
h.update
If h.pos-scroll<-64 Then hurdles.remove h
Next
If vely<6 Then vely:+0.16
py:+vely
If py>=0 Then
py=0
vely=0
panim=0
If KeyHit(KEY_SPACE) And KeyDown(KEY_SPACE) And Not KeyDown(KEY_DOWN) Then charge=32 vely=-4
If KeyDown(KEY_DOWN) Then panim=1
Else
panim=2
EndIf
If charge>0 And KeyDown(KEY_SPACE) Then
vely=-4
charge:-1
Else
charge=0
EndIf
SetScale 1,1
If CollideImage(sprite,32,240-64+Floor(py),panim,1,0) Then dead=1 FlushKeys
SetScale z,z
ResetCollisions
EndIf
Cls
SetScale z,z
For i = 0 To 4
DrawImage background,(320-(i*80+scroll*0.05) Mod 384)*z,Sin(i*45)*32*z,0
If i Mod 2 Then DrawImage background,(320-(i*80+Sin(i*45)*16+scroll*0.3) Mod 384)*z,176*z,1
Next
For i=1 To 2
For j=0 To 320/16
DrawImage tiles,(-scroll Mod 16+j*16)*z,(240-i*16)*z,1
Next
Next
SetColor 0,0,0;DrawRect 0,208*z,320,1;SetColor 255,255,255
For h=EachIn hurdles
h.draw
Next
DrawImage sprite,32*z,(176+Floor(py))*z,panim
dotxt Int(scroll/10)*10+level*2000+" score",4,4
If count>1 Then dotxt Int(count),156,112
If count<=1 And count>0 Then dotxt "Los!",144,112
If dead Then
x=160
y=112
SetColor 255,0,0;SetAlpha 0.5
DrawRect 0,0,320*z,240*z
SetAlpha 1
dotxt "GameOver",x-32,y
dotxt "Retry?",x-24,y+64
dotxt "Yes        No",x-52,y+96
anim=anim Mod 180+4
dotxt ">",x-Sin(anim)*8-60+sel*88,y+96
EndIf
Flip
Until AppTerminate() Or KeyHit(KEY_ESCAPE)
End

Function dotxt(text:String,x%,y%)
SetColor 0,0,0
For i=-1 To 1
For j=-1 To 1
DrawText text,(x+i)*z,(y+j)*z
Next
Next
SetColor 255,255,255
DrawText text,x*z,y*z
End Function