Graphics 400,300,32,2
SetBuffer BackBuffer()
SeedRnd MilliSecs()
AppTitle ":: RescueMouse :: Bugfix 1 :: Igor dankt. ::"

Type Wave
	Field X,Y,S#,D#,SP#
End Type

Type Ball
	Field X#,Y#,A#
End Type

Global ball_img=LoadImage("ball.png")
MaskImage ball_img,255,255,255
MidHandle ball_img
Global background_img=LoadImage("sky.png")
Global ball_speed#=1

Global gameover=1
Global starttime,gametime,balltime

NewGame()

Repeat

	If MouseHit(2) And gameover=1 Then
		gameover=0
		starttime=MilliSecs()
		gametime=0
		balltime=0
		ball_speed#=1
	EndIf
	
	
	If gameover=0 Then
		UpdateWaves()
		MoveBalls()
	
		BallCollision()
		MouseCollision()
		Difficulty()
	EndIf
	
	
	Cls
				
		DrawBackground()
		DrawBalls()
		DrawWaves()
		Display()
	
	Flip
	
	If KeyHit(1) Then
		If gameover=0 Then
			gameover=1
			NewGame()
			FlushKeys()
		EndIf
		If gameover=1 Then Exit
	EndIf
	
	Delay 10

Forever

Function DrawBackground()

	DrawImage background_img,0,0
	
End Function
	
	
Function DrawBalls()

	For Ball.Ball=Each Ball
		DrawImage ball_img,Ball\X,Ball\Y
	Next

End Function

Function DrawWaves()
	
	
	For Wave.Wave=Each Wave
		
		For A=1 To 360 Step 9
			CopyRect Wave\X+(Cos(-A)*Wave\D#),Wave\Y-(Sin(-A)*Wave\D#),Wave\S,Wave\S,Wave\X#+(Cos(-A)*(Wave\D#-2)),Wave\Y-(Sin(-A)*(Wave\D#-2)),BackBuffer(),BackBuffer()
		Next
	Next
	
End Function

Function AddBall(X,Y,A=4)

	Ball.Ball=New Ball
	Ball\X=X
	Ball\Y=Y
	If A<>4 Then Ball\A=A
	If A=4 Then Ball\A=Rand(0,3)
	

End Function

Function CreateWave(X,Y)
	
	Wave.Wave=New Wave
	Wave\X=X
	Wave\Y=Y
	Wave\D#=35
	Wave\S=Rand(7,11)
	Wave\SP#=Rnd(2,4)

End Function

Function UpdateWaves()

	For Wave.Wave=Each Wave
		Wave\D#=Wave\D#+Wave\SP#
		If Wave\D#>300 Then Delete Wave.Wave
	Next

End Function

Function MoveBalls()

	For Ball.Ball=Each Ball
		Ball\X=Ball\X-(Cos(Abs(Ball\A)*90+45)*ball_speed#)
		Ball\Y=Ball\Y+(Sin(Abs(Ball\A)*90+45)*ball_speed#)
	Next

End Function

Function BallCollision()

	For Ball.Ball=Each Ball
		If Ball\X<18 Then
			CreateWave(Ball\X,Ball\Y)
			If Int(Ball\A)=0 Then Ball\A=1+Rnd(-0.1,0.1)
			If Int(Ball\A)=3 Then Ball\A=2+Rnd(-0.1,0.1)
		EndIf
		
		If Ball\X>GraphicsWidth()-18 Then 
			CreateWave(Ball\X,Ball\Y)
			If Int(Ball\A)=1 Then Ball\A=0+Rnd(-0.1,0.1)
			If Int(Ball\A)=2 Then Ball\A=3+Rnd(-0.1,0.1)
		EndIf
		
		If Ball\Y<18 Then
			CreateWave(Ball\X,Ball\Y)
			If Int(Ball\A)=3 Then Ball\A=0+Rnd(-0.1,0.1)
			If Int(Ball\A)=2 Then Ball\A=1+Rnd(-0.1,0.1)
		EndIf
		
		If Ball\Y>GraphicsHeight()-18 Then
			CreateWave(Ball\X,Ball\Y)
			If Int(Ball\A)=0 Then Ball\A=3+Rnd(-0.1,0.1)
			If Int(Ball\A)=1 Then Ball\A=2+Rnd(-0.1,0.1)
		EndIf
	Next

End Function

Function MouseCollision()
	
	MoveMouse MouseX(), MouseY()
	
	If MouseX()<10 Then MoveMouse 10,MouseY()
	If MouseX()>GraphicsWidth()-10 Then MoveMouse GraphicsWidth()-10,MouseY()
	
	If MouseY()<10 Then MoveMouse MouseX(),10
	If MouseY()>GraphicsHeight()-10 Then MoveMouse MouseX(),GraphicsHeight()-10
	
	For Ball.Ball=Each Ball
		If ImageRectCollide(ball_img,Ball\X,Ball\Y,0,MouseX(),MouseY(),1,1) Then
			gameover=1
			NewGame()
			FlushMouse()
		EndIf
	Next

End Function

Function Difficulty()

	ball_speed#=ball_speed#+0.001
	
	If gametime-balltime=>7500 Then
		balltime=gametime
		For Ball.Ball=Each Ball
			AddBall(Ball\X,Ball\Y,Ball\A+1)
			Exit
		Next
	EndIf


End Function

Function Display()
	
	Color 0,0,0
	If gameover=0 Then gametime=MilliSecs()-starttime
	If gameover=0 Then Text GraphicsWidth()/2,GraphicsHeight()-25,(gametime/1000) + " Sekunden",1
	
	If gameover=1 Then Text GraphicsWidth()/2,GraphicsHeight()-25,(gametime/1000) + " Sekunden - Rechte Maustaste fr neues Spiel",1
	;If gameover=1 Then Text 
	
End Function

Function NewGame()

	For Ball.Ball=Each Ball
		Delete Ball.Ball
	Next
	For B=0 To 3
		AddBall(Rand(18,GraphicsWidth()-18),Rand(18,GraphicsHeight()-18))
	Next
			
End Function